#include <SPI.h>
#include "RF24.h"

struct WMC{
  byte command;
  int x;
  int y;
  byte pyl;
  byte checksum;
};

RF24 radio(1,2); //use SPI + 8 and 9

byte addresses[][6] = {"radio","motor"};
long t1;
long t2;


void setup(){
  Serial.begin(115200);
  
  radio.begin();
  radio.setPALevel(RF24_PA_LOW); //amplifier power level
  radio.openWritingPipe(addresses[0]);
  radio.openReadingPipe(1,addresses[1]);
  radio.startListening();
}

void loop(){
WMC temp;
t1=millis();
    
    if(radio.available()){
      while (radio.available()){
        radio.read( &temp, 7);
      }
      byte cchecksum = temp.command+temp.x+temp.y+temp.pyl;
      Serial.print(temp.command);Serial.print('\t');Serial.print(temp.x);Serial.print('\t');Serial.print(temp.y);Serial.print('\t');Serial.print(temp.checksum);Serial.print('\t');
      if(cchecksum==temp.checksum){Serial.println('k');}
      t2=t1;
    }

}
