#include <string.h>

#define serbuflen 50 //total length of single line of input 
#define nounnum 3  //number of nouns (parameters)

char serbuf[serbuflen+1];   //buffer for storing serial input text
char* verb;                 //stores command text
char* noun[nounnum]; //stores pointers to parameters
byte nouns;
const char delim[2] = " ";

void serialControl(){
  if(!Serial.available()){return;}
  byte slen=0;
  bool getline=1;
  bool ok=0;                          //checks if is bad command or not
  while(getline){
    if(Serial.available()){
      serbuf[slen] = Serial.read();
      if(serbuf[slen]==13){getline=0;}
      if(serbuf[slen]==8){slen-=2;if(slen==254){slen++;}else{Serial.write(8);Serial.write(32);Serial.write(8);}}else{Serial.write(serbuf[slen]);} 
      //Serial.print(slen);Serial.print('\t');Serial.write(ubuf[slen]);Serial.print('\t');Serial.println(ubuf[slen]);
      slen++;
    }
  }
  slen--;                             //remove last character (CR) and replace with string terminator
  serbuf[slen]='\0';                  //terminate the serial buffer string
     
  verb=strtok(serbuf, delim);
  if(verb == NULL){ ok=1; }           //no command, just reprint > prompt
  nouns = 0;                          //seperate nouns
  char* nountemp;
  nountemp=strtok(NULL, delim);
  while(nountemp != NULL ){
      noun[nouns]=nountemp;
      nouns++;
      nountemp = strtok(NULL, delim);
      if(nouns>=nounnum-1){nouns=nounnum-1;}
  }
  char* pend;                         //used in strtol, normally not used.
  Serial.print(F("\r\n"));
  
  //******************************************************************************************************************************
  
  if(0==strcmp_P(verb,PSTR("blink"))){
    ledBlinkrate=strtol(noun[0], &pend, 10);
  }
  if(0==strcmp_P(verb,PSTR("s"))){
    speedLeftInput=strtol(noun[0], &pend, 10);
  }
  if(0==strcmp_P(verb,PSTR("en"))){
    motorsEnable();
  }
  if(0==strcmp_P(verb,PSTR("dn"))){
    motorsDisable();
  }
  if(0==strcmp_P(verb,PSTR("m"))){
    motorsPower(strtol(noun[0], &pend, 10),strtol(noun[1], &pend, 10));
  }

  if(0==strcmp_P(verb,PSTR("p"))){ Kp = strtol(noun[0], &pend, 10); myPID.SetTunings(Kp, Ki, Kd); }
  if(0==strcmp_P(verb,PSTR("i"))){ Ki = strtol(noun[0], &pend, 10); myPID.SetTunings(Kp, Ki, Kd); }
  if(0==strcmp_P(verb,PSTR("d"))){ Kd = strtol(noun[0], &pend, 10); myPID.SetTunings(Kp, Ki, Kd); }

  if(0==strcmp_P(verb,PSTR("g"))){ 
    myPID.SetMode(AUTOMATIC);
    myPID.SetSampleTime(50);
    myPID.SetOutputLimits(-255, 255);
  }

  Serial.print(F(">"));
}
