byte cycle;
byte cycleLast;

long count;

unsigned long millistimer;
int cspeedcount;
int cspeed;
float fspeed;

void setup() {
  pinMode(2, INPUT);
  pinMode(3, INPUT);
  Serial.begin(9600);
  attachInterrupt(digitalPinToInterrupt(2), isr, CHANGE);
  attachInterrupt(digitalPinToInterrupt(3), isr, CHANGE);
}

void loop(){
  if(millis()%100==0){
  Serial.print(fspeed);
  Serial.print(' ');
  Serial.print((float)count/24.00,2);
  Serial.print(' ');
  Serial.println(count);
  }

  if(millis() - millistimer >= 1){
    millistimer=millis();
    cspeed=cspeedcount;
    cspeedcount=0;
    fspeed = fspeed*0.95 + cspeed*0.05*1000/24;
   }

}

void isr(){
   cycle = (PIND & 0b00001100)>>2;
   switch(cycle){case 2: cycle=3; break; case 3: cycle=2; break;} //cycle is now 0-1-2-3

   if(cycleLast==3&&cycle==0){count++; cspeedcount++;
   }else if(cycleLast==0&&cycle==3){count--; cspeedcount--;
   }else if(cycleLast<cycle){count++; cspeedcount++;
   }else{count--; cspeedcount--;
   }

   cycleLast=cycle;
}
